#ifndef _RLEINSTREAM_H_
#define _RLEINSTREAM_H_

#include <stdio.h>
#include "Stream.h"

namespace Framework
{

	class CRleInStream : public CStream
	{
	public:
						CRleInStream(FILE*);
		virtual			~CRleInStream();
		virtual uint64	Read(void*, uint64);
		virtual uint64	Write(const void*, uint64);
		virtual void	Seek(int64, STREAM_SEEK_DIRECTION);
		virtual uint64	Tell();
		virtual bool	IsEOF();

	private:
		enum BUFFERALLOCSIZE
		{
			BUFFERALLOCSIZE = 0xFF,
		};

		void			FillBuffer();

		uint8*			m_pBuffer;
		unsigned int	m_nBufferSize;
		unsigned int	m_nBufferPosition;
		FILE*			m_pStream;
	};

}

#endif
