#include "GZipStream.h"

using namespace Framework;

CGZipStream::CGZipStream(const char* sPath, const char* sMode)
{
	m_File = gzopen(sPath, sMode);
	if(m_File == Z_NULL)
	{
		throw "Couldn't open file specified.";
	}
}

CGZipStream::~CGZipStream()
{
	gzclose(m_File);
}

uint64 CGZipStream::Read(void* pData, uint64 nSize)
{
	return gzread(m_File, pData, (unsigned int)nSize);
}

uint64 CGZipStream::Write(const void* pData, uint64 nSize)
{
	return gzwrite(m_File, (const voidp)pData, (unsigned int)nSize);
}

void CGZipStream::Seek(int64 nAmount, STREAM_SEEK_DIRECTION nPosition)
{
	
}

uint64 CGZipStream::Tell()
{
	return gztell(m_File);
}

bool CGZipStream::IsEOF()
{
	return (gzeof(m_File) != 0);
}
