#include <malloc.h>
#include <string.h>
#include "RleInStream.h"
#include "PtrMacro.h"

using namespace Framework;

CRleInStream::CRleInStream(FILE* pStream)
{
	if(pStream == NULL)
	{
		throw "Invalid file handle.";
	}

	m_pStream			= pStream;
	m_pBuffer			= (uint8*)malloc(BUFFERALLOCSIZE);
	m_nBufferSize		= 0;
	m_nBufferPosition	= 0;
}

CRleInStream::~CRleInStream()
{
	fclose(m_pStream);
	FREEPTR(m_pBuffer);
}

void CRleInStream::FillBuffer()
{
	uint8 nRun;
	uint8 nChar;

	fread(&nRun, 1, 1, m_pStream);
	fread(&nChar, 1, 1, m_pStream);

	memset(m_pBuffer, nChar, nRun);
	m_nBufferSize = nRun;
	m_nBufferPosition = 0;
}

uint64 CRleInStream::Read(void* pData, uint64 nSize)
{
	unsigned int nRest;
	uint64 nTotalSize;

	nTotalSize = nSize;

	nRest = m_nBufferSize - m_nBufferPosition;

	if(nRest == 0)
	{
		FillBuffer();
	}

	while(1)
	{
		nRest = m_nBufferSize - m_nBufferPosition;

		if(nSize <= nRest)
		{
			memcpy(pData, m_pBuffer + m_nBufferPosition, (size_t)nSize);
			m_nBufferPosition += (unsigned int)nSize;
			return nTotalSize;
		}

		memcpy(pData, m_pBuffer + m_nBufferPosition, nRest);

		m_nBufferPosition += nRest;
		nSize -= nRest;
		pData = (uint8*)pData + nRest;

		FillBuffer();
	}
}

uint64 CRleInStream::Write(const void* pData, uint64 nSize)
{
	return 0;
}

void CRleInStream::Seek(int64 nAmount, STREAM_SEEK_DIRECTION nPosition)
{

}

uint64 CRleInStream::Tell()
{
	return 0;
}

bool CRleInStream::IsEOF()
{
	return false;
}
