/*

	Framework - TreeView.cpp
	File Version 1.0.000

*/

#include "win32/TreeView.h"

using namespace Framework;

CTreeView::CTreeView(HWND hParent, RECT* pR, unsigned long nStyle, unsigned long nExStyle)
{
	InitCommonControls();
	Create(nExStyle, WC_TREEVIEW, _X(""), WS_CHILD | WS_VISIBLE | nStyle, pR, hParent, NULL);
}

HTREEITEM CTreeView::InsertItem(TVINSERTSTRUCT* pI)
{
	return (HTREEITEM)TreeView_InsertItem(m_hWnd, pI);
}

HTREEITEM CTreeView::GetSelection()
{
	return (HTREEITEM)TreeView_GetSelection(m_hWnd);
}

bool CTreeView::GetItem(HTREEITEM hItem, TVITEM* pI)
{
	pI->hItem = hItem;
	return ((TreeView_GetItem(m_hWnd, pI) == TRUE) ? true : false);
}

HTREEITEM CTreeView::GetRoot()
{
	return TreeView_GetRoot(m_hWnd);
}

bool CTreeView::SetSelection(HTREEITEM hItem)
{
	return ((TreeView_SelectItem(m_hWnd, hItem) == TRUE) ? true : false);
}

bool CTreeView::Expand(HTREEITEM hItem, unsigned int nFlags)
{
	return ((TreeView_Expand(m_hWnd, hItem, nFlags) == TRUE) ? true : false);
}

bool CTreeView::DeleteAllItems()
{
	return ((TreeView_DeleteAllItems(m_hWnd) == TRUE) ? true : false);
}
